    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------------
    028     * CharacterObjectDescription.java
    029     * -------------------------------
    030     * (C)opyright 2003, 2004, by Thomas Morgner and Contributors.
    031     *
    032     * Original Author:  Thomas Morgner;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: CharacterObjectDescription.java,v 1.3 2005/11/14 10:59:44 mungady Exp $
    036     *
    037     * Changes (from 19-Feb-2003)
    038     * -------------------------
    039     * 19-Feb-2003 : Added standard header and Javadocs (DG);
    040     * 29-Apr-2003 : Distilled from the JFreeReport project and moved into JCommon
    041     *
    042     */
    043
    044    package org.jfree.xml.factory.objects;
    045
    046    /**
    047     * An object-description for a <code>Character</code> object.
    048     *
    049     * @author Thomas Morgner
    050     */
    051    public class CharacterObjectDescription extends AbstractObjectDescription {
    052
    053        /**
    054         * Creates a new object description.
    055         */
    056        public CharacterObjectDescription() {
    057            super(Character.class);
    058            setParameterDefinition("value", String.class);
    059        }
    060
    061        /**
    062         * Creates a new object (<code>Character</code>) based on this description object.
    063         *
    064         * @return The <code>Character</code> object.
    065         */
    066        public Object createObject() {
    067            final String o = (String) getParameter("value");
    068            if (o == null) {
    069                return null;
    070            }
    071            if (o.length() > 0) {
    072                return new Character(o.charAt(0));
    073            }
    074            else {
    075                return null;
    076            }
    077        }
    078
    079        /**
    080         * Sets the parameters of this description object to match the supplied object.
    081         *
    082         * @param o  the object (should be an instance of <code>Character</code>).
    083         * @throws ObjectFactoryException if there is a
    084         * problem while reading the properties of the given object.
    085         */
    086        public void setParameterFromObject(final Object o) throws ObjectFactoryException {
    087            if (!(o instanceof Character)) {
    088                throw new ObjectFactoryException("The given object is no java.lang.Character.");
    089            }
    090
    091            setParameter("value", String.valueOf(o));
    092        }
    093
    094        /**
    095         * Tests for equality.
    096         *
    097         * @param o  the object to test.
    098         *
    099         * @return A boolean.
    100         */
    101        public boolean equals(final Object o) {
    102            if (this == o) {
    103                return true;
    104            }
    105            if (!(o instanceof AbstractObjectDescription)) {
    106                return false;
    107            }
    108
    109            final AbstractObjectDescription abstractObjectDescription = (AbstractObjectDescription) o;
    110
    111            if (Character.TYPE.equals(abstractObjectDescription.getObjectClass())) {
    112                return true;
    113            }
    114            if (Character.class.equals(abstractObjectDescription.getObjectClass())) {
    115                return true;
    116            }
    117            return false;
    118        }
    119
    120        /**
    121         * Returns a hash code for the object.
    122         *
    123         * @return The hash code.
    124         */
    125        public int hashCode() {
    126            return getObjectClass().hashCode();
    127        }
    128
    129    }